import * as i6 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy } from '@angular/core';
import * as i1 from '@smallstack/file-components';
import { FilePreviewComponent } from '@smallstack/file-components';
import { I18nComponent } from '@smallstack/i18n-components';
import { StoreModelComponent } from '@smallstack/store-components';
import { filterNullish, getJsonByPath } from '@smallstack/utils';
import { BaseWidgetComponent } from '@smallstack/widget-core';
import { combineLatest } from 'rxjs';

class FilesWidgetComponent extends BaseWidgetComponent {
    constructor(fileStore) {
        super();
        this.fileStore = fileStore;
        this.subscription.add(combineLatest([this.context$, this.data$])
            .pipe(filterNullish({ filterEmptyObjects: true }))
            .subscribe(([context, data]) => {
            this.fileIds = getJsonByPath(context, data?.contextProperty);
            this.cdr.markForCheck();
        }));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: FilesWidgetComponent, deps: [{ token: i1.FileStore }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: FilesWidgetComponent, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<div class=\"smallstack-grid small\">\n  <ng-container *ngIf=\"fileIds; else noFiles\">\n    <div *ngFor=\"let fileId of fileIds\" class=\"smallstack-grid-card\">\n      <div class=\"content\">\n        <smallstack-store-model [store]=\"fileStore\" [modelId]=\"fileId\">\n          <ng-template let-model=\"model\">\n            <smallstack-file-preview [file]=\"model\"></smallstack-file-preview>\n          </ng-template>\n        </smallstack-store-model>\n      </div>\n    </div>\n  </ng-container>\n</div>\n<ng-template #noFiles><smallstack-i18n [data]=\"data.noFilesFoundText\"></smallstack-i18n></ng-template>\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i6.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i6.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: FilePreviewComponent, selector: "smallstack-file-preview", inputs: ["showSize", "showName", "file"] }, { kind: "component", type: StoreModelComponent, selector: "smallstack-store-model", inputs: ["store", "modelId", "notFound"] }, { kind: "component", type: I18nComponent, selector: "smallstack-i18n", inputs: ["data", "showMissingKey", "replacers", "locale", "translationStore"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: FilesWidgetComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [CommonModule, FilePreviewComponent, StoreModelComponent, I18nComponent], template: "<div class=\"smallstack-grid small\">\n  <ng-container *ngIf=\"fileIds; else noFiles\">\n    <div *ngFor=\"let fileId of fileIds\" class=\"smallstack-grid-card\">\n      <div class=\"content\">\n        <smallstack-store-model [store]=\"fileStore\" [modelId]=\"fileId\">\n          <ng-template let-model=\"model\">\n            <smallstack-file-preview [file]=\"model\"></smallstack-file-preview>\n          </ng-template>\n        </smallstack-store-model>\n      </div>\n    </div>\n  </ng-container>\n</div>\n<ng-template #noFiles><smallstack-i18n [data]=\"data.noFilesFoundText\"></smallstack-i18n></ng-template>\n" }]
        }], ctorParameters: function () { return [{ type: i1.FileStore }]; } });

export { FilesWidgetComponent };
//# sourceMappingURL=smallstack-data-widgets-files-widget.component-7d9c7a2a.mjs.map
