import * as i6 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy } from '@angular/core';
import { LoadingElementDirective } from '@smallstack/common-components';
import { I18nComponent } from '@smallstack/i18n-components';
import { IconComponent } from '@smallstack/theme-components';
import * as i1 from '@smallstack/typesystem-client';
import { getJsonByPath } from '@smallstack/utils';
import { BaseWidgetComponent } from '@smallstack/widget-core';

class OpenDetailsBtnWidgetComponent extends BaseWidgetComponent {
    constructor(frontendTypeRegistry) {
        super();
        this.frontendTypeRegistry = frontendTypeRegistry;
    }
    openDetail() {
        return async () => {
            const model = this.context && this.data.contextProperty
                ? getJsonByPath(this.context, this.data.contextProperty)
                : this.context;
            await this.frontendTypeRegistry.openDetail(this.data.type, model);
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: OpenDetailsBtnWidgetComponent, deps: [{ token: i1.FrontendTypeRegistry }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: OpenDetailsBtnWidgetComponent, isStandalone: true, selector: "smallstack-open-details-btn-widget", usesInheritance: true, ngImport: i0, template: "<button\n  [loadingFn]=\"openDetail()\"\n  class=\"btn btn-primary flex flex-row gap-1 justify-center place-items-center\"\n  [ngClass]=\"{ 'btn-block': data?.btnAsBlock === true }\"\n>\n  <smallstack-icon *ngIf=\"data?.icon\" [name]=\"data.icon\" size=\"24\" style=\"margin: unset\"></smallstack-icon>\n  <smallstack-i18n *ngIf=\"data?.text\" [data]=\"data.text\"></smallstack-i18n>\n</button>\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i6.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i6.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: I18nComponent, selector: "smallstack-i18n", inputs: ["data", "showMissingKey", "replacers", "locale", "translationStore"] }, { kind: "component", type: IconComponent, selector: "smallstack-icon", inputs: ["theme", "size", "name", "alias", "action", "actionSize", "spinning", "actionSpinning", "color", "themeColor", "actionColor", "badge", "dynamic", "badgeColor"], outputs: ["iconError"] }, { kind: "directive", type: LoadingElementDirective, selector: "[loadingFn]", inputs: ["loadingFn", "isLoading"], exportAs: ["loadingFn"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: OpenDetailsBtnWidgetComponent, decorators: [{
            type: Component,
            args: [{ selector: "smallstack-open-details-btn-widget", standalone: true, imports: [CommonModule, I18nComponent, IconComponent, LoadingElementDirective], changeDetection: ChangeDetectionStrategy.OnPush, template: "<button\n  [loadingFn]=\"openDetail()\"\n  class=\"btn btn-primary flex flex-row gap-1 justify-center place-items-center\"\n  [ngClass]=\"{ 'btn-block': data?.btnAsBlock === true }\"\n>\n  <smallstack-icon *ngIf=\"data?.icon\" [name]=\"data.icon\" size=\"24\" style=\"margin: unset\"></smallstack-icon>\n  <smallstack-i18n *ngIf=\"data?.text\" [data]=\"data.text\"></smallstack-i18n>\n</button>\n" }]
        }], ctorParameters: function () { return [{ type: i1.FrontendTypeRegistry }]; } });

export { OpenDetailsBtnWidgetComponent };
//# sourceMappingURL=smallstack-data-widgets-open-details-btn-widget.component-c4982655.mjs.map
