import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy } from '@angular/core';
import * as i3 from '@smallstack/common-components';
import { BaseWidgetComponent } from '@smallstack/widget-core';

class StoreConfiguratorWidgetComponent extends BaseWidgetComponent {
    constructor(storeRegistry) {
        super();
        this.subscription.add(this.data$.subscribe(async (data) => {
            if (data?.typePath) {
                const store = storeRegistry.getStore(data.typePath);
                if (data.resetStoreOnPageLoad)
                    await store.reset({ keepSearch: false, keepSort: true });
                if (data.loadStoreOnPageLoad)
                    await store.load();
            }
        }));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: StoreConfiguratorWidgetComponent, deps: [{ token: i3.StoreRegistry }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: StoreConfiguratorWidgetComponent, isStandalone: true, selector: "smallstack-store-configurator-widget", usesInheritance: true, ngImport: i0, template: ``, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: StoreConfiguratorWidgetComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "smallstack-store-configurator-widget",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: ``,
                    standalone: true,
                    imports: []
                }]
        }], ctorParameters: function () { return [{ type: i3.StoreRegistry }]; } });

export { StoreConfiguratorWidgetComponent };
//# sourceMappingURL=smallstack-data-widgets-store-configurator-widget.component-992bd334.mjs.map
