import * as i6 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy } from '@angular/core';
import * as i2 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import { MatInputModule } from '@angular/material/input';
import { MatFormFieldModule } from '@angular/material/form-field';
import { RangePipe, OverlayComponent } from '@smallstack/common-components';
import { IconComponent } from '@smallstack/theme-components';
import { getJsonByPath } from '@smallstack/utils';
import { BaseWidgetComponent, WidgetChildComponent } from '@smallstack/widget-core';

class TableWidgetComponent extends BaseWidgetComponent {
    ngOnInit() {
        if (!this.data.contextConditions)
            this.data.contextConditions = [];
    }
    rowConditionTrue(index) {
        if (this.editMode || !this.data?.contextConditions || !this.data?.contextConditions[index])
            return true;
        const value = getJsonByPath(this.context, this.data.contextConditions[index]);
        return value !== null && value !== undefined && value !== "";
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: TableWidgetComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: TableWidgetComponent, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<table\n  [style.border-spacing]=\"data.tableSpacing\"\n  [style.border-width]=\"data.tableBorderWidth\"\n  [style.border-style]=\"data.tableBorderStyle\"\n  [style.border-color]=\"data.tableBorderColor\"\n  [style.border-collapse]=\"data.tableBorderCollapse ? '' : 'collapse'\"\n  #table\n  style=\"width: 100%\"\n>\n  <tbody>\n    <ng-container *ngFor=\"let row of data.rows | range; let ri = index; ngForTrackById\">\n      <tr *ngIf=\"rowConditionTrue(ri)\">\n        <ng-container *ngIf=\"editMode\">\n          <div class=\"flex h-full justify-start place-items-center\">\n            <smallstack-overlay #conditionOverlay>\n              <div class=\"card card-bordered card-compact bg-white\">\n                <div class=\"card-body\">\n                  <div class=\"text-lg\">Bedingung</div>\n                  <div class=\"text-sm\"\n                    >Legen Sie hier eine Bedingung fest, die wahr sein muss, damit die Tabellenzeile angezeigt\n                    wird.</div\n                  >\n                  <div class=\"form-control\">\n                    <label class=\"label\">\n                      <span class=\"label-text\">Kontext Variable gesetzt</span>\n                    </label>\n                    <input class=\"input input-bordered\" [(ngModel)]=\"data.contextConditions[ri]\" />\n                  </div>\n                  <button (click)=\"conditionOverlay.closeOverlay()\" class=\"btn btn-block\">Schlie\u00DFen</button>\n                </div>\n              </div>\n            </smallstack-overlay>\n            <button class=\"btn-action\" (click)=\"conditionOverlay.openOverlay()\">\n              <smallstack-icon name=\"source-code\"></smallstack-icon>\n            </button>\n          </div>\n        </ng-container>\n        <td\n          *ngFor=\"let col of data.cols | range; let ci = index; ngForTrackById\"\n          [style.padding]=\"data.tablePadding\"\n          [style.border-width]=\"data.tableBorderWidth\"\n          [style.border-style]=\"data.tableBorderStyle\"\n          [style.border-color]=\"data.tableBorderColor\"\n          [style.vertical-align]=\"data.tdVerticalAlign\"\n        >\n          <smallstack-widget-child\n            [(data)]=\"data\"\n            (dataChange)=\"dataChange.emit($event)\"\n            [property]=\"ri + ':' + ci\"\n            [context]=\"context$ | async\"\n          >\n          </smallstack-widget-child>\n        </td>\n      </tr>\n    </ng-container>\n  </tbody>\n</table>\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i6.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i6.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i6.AsyncPipe, name: "async" }, { kind: "pipe", type: RangePipe, name: "range" }, { kind: "component", type: OverlayComponent, selector: "smallstack-overlay", inputs: ["hasBackdrop"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "ngmodule", type: MatInputModule }, { kind: "component", type: IconComponent, selector: "smallstack-icon", inputs: ["theme", "size", "name", "alias", "action", "actionSize", "spinning", "actionSpinning", "color", "themeColor", "actionColor", "badge", "dynamic", "badgeColor"], outputs: ["iconError"] }, { kind: "component", type: WidgetChildComponent, selector: "smallstack-widget-child", inputs: ["data", "context", "property", "widgetTags"], outputs: ["dataChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: TableWidgetComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [
                        CommonModule,
                        RangePipe,
                        OverlayComponent,
                        FormsModule,
                        MatFormFieldModule,
                        MatInputModule,
                        IconComponent,
                        WidgetChildComponent
                    ], template: "<table\n  [style.border-spacing]=\"data.tableSpacing\"\n  [style.border-width]=\"data.tableBorderWidth\"\n  [style.border-style]=\"data.tableBorderStyle\"\n  [style.border-color]=\"data.tableBorderColor\"\n  [style.border-collapse]=\"data.tableBorderCollapse ? '' : 'collapse'\"\n  #table\n  style=\"width: 100%\"\n>\n  <tbody>\n    <ng-container *ngFor=\"let row of data.rows | range; let ri = index; ngForTrackById\">\n      <tr *ngIf=\"rowConditionTrue(ri)\">\n        <ng-container *ngIf=\"editMode\">\n          <div class=\"flex h-full justify-start place-items-center\">\n            <smallstack-overlay #conditionOverlay>\n              <div class=\"card card-bordered card-compact bg-white\">\n                <div class=\"card-body\">\n                  <div class=\"text-lg\">Bedingung</div>\n                  <div class=\"text-sm\"\n                    >Legen Sie hier eine Bedingung fest, die wahr sein muss, damit die Tabellenzeile angezeigt\n                    wird.</div\n                  >\n                  <div class=\"form-control\">\n                    <label class=\"label\">\n                      <span class=\"label-text\">Kontext Variable gesetzt</span>\n                    </label>\n                    <input class=\"input input-bordered\" [(ngModel)]=\"data.contextConditions[ri]\" />\n                  </div>\n                  <button (click)=\"conditionOverlay.closeOverlay()\" class=\"btn btn-block\">Schlie\u00DFen</button>\n                </div>\n              </div>\n            </smallstack-overlay>\n            <button class=\"btn-action\" (click)=\"conditionOverlay.openOverlay()\">\n              <smallstack-icon name=\"source-code\"></smallstack-icon>\n            </button>\n          </div>\n        </ng-container>\n        <td\n          *ngFor=\"let col of data.cols | range; let ci = index; ngForTrackById\"\n          [style.padding]=\"data.tablePadding\"\n          [style.border-width]=\"data.tableBorderWidth\"\n          [style.border-style]=\"data.tableBorderStyle\"\n          [style.border-color]=\"data.tableBorderColor\"\n          [style.vertical-align]=\"data.tdVerticalAlign\"\n        >\n          <smallstack-widget-child\n            [(data)]=\"data\"\n            (dataChange)=\"dataChange.emit($event)\"\n            [property]=\"ri + ':' + ci\"\n            [context]=\"context$ | async\"\n          >\n          </smallstack-widget-child>\n        </td>\n      </tr>\n    </ng-container>\n  </tbody>\n</table>\n" }]
        }] });

export { TableWidgetComponent };
//# sourceMappingURL=smallstack-data-widgets-table-widget.component-33cbf184.mjs.map
